#include <C8051F340.h>
#include <intrins.h>

sbit Lcd_RS = P1^0;
sbit Lcd_E = P1^1;
sbit Lcd_RW = P1^2;

/* Pruefung , ob Anzeige ready */

anzready()
{
  unsigned char busy;

  Lcd_E = 1;                         /* falling edge of E und */
  _nop_();              			 /* Pegelverlngerung wegen */
  _nop_();		                     /* Ansteuerung ber Port */
  
  Lcd_E = 0;
  _nop_();
  _nop_();

  Lcd_RW = 1;                         /* R/W = high fr Lesen von busy */
  Lcd_RS = 0;                         /* RS = low fr Instruktionen */
  //_nop_();
  //_nop_();
  P3 = 1;

  do
  { 
    Lcd_E = 1;                        /* E = high */
	//Hier gehrt noch die Umschaltung von P4 auf Inputs hin
	busy = P4;
    busy &= 0x80;
    Lcd_E = 0;
    _nop_(); 
  }
  while (busy);
  Lcd_RW = 0;                         /* R/W = low fr Schreiben */
  P3 = 2;
}


/* Anzeige loeschen */

clranz()
{
  Lcd_RW = 0;                    /* R/W = low fr Schreiben */
  Lcd_RS = 0;                    /* RS = low fr Instruktionen */
  Lcd_E = 0;                     /* E = low */
  P4 = 0x01;
  anzready();
}


/* Initialisierungsroutine */

anzinit()
{
  unsigned int cnt1;
 
  Lcd_RW = 0;                    /* R/W = low fr Schreiben */
  Lcd_RS = 0;                    /* RS = low fr Instruktionen */
  Lcd_E = 0; 				     /* E = low */
  P4 = 0x38;
  anzready();
  for (cnt1 = 0; cnt1 < 400; cnt1++);

  P4 = 0x38;
  anzready();
  for (cnt1 = 0; cnt1 < 400; cnt1++);
 
  P4 = 0x38;
  anzready();
  for (cnt1 = 0; cnt1 < 400; cnt1++);

  P4 = 0x38;
  anzready(); 
  for (cnt1 = 0; cnt1 < 400; cnt1++);

  P4 = 0x0C;
  anzready();

  P4 = 0x06;
  anzready();

  P4 = 0x01;
  anzready();
}

/* Ausgabe eines Textstrings */

writes(unsigned char *text)
{
 while(*text)
 {
   Lcd_RS = 1;                              /* RS = high fr Daten */
   P4 = *text++;
   anzready();
 }
}

void main()
{
	PCA0MD &= ~0x40;                    // Disable Watchdog timer
	OSCICN = 0x80;                      // Set internal oscillator to run
                                       // at its lowest frequency
	//Outputmode von Port1 und Port4 auf "push-pull" stellen
	P1MDOUT = 0xFF;
	P4MDOUT = 0xFF;
	P3MDOUT = 0xFF;
	XBR1     = 0x40;                    // Ports als GPIO freigeben

	anzinit();
	writes("funzt!!!");
	while(1);

}
